/* ************************************************************************* **
** Started Tue Jul 30 16:25:44 NZST 2002				     **
** ************************************************************************* */
#ifndef __GLGIZMO_HH__
#define __GLGIZMO_HH__

/* ************************************************************************* */
#include <qevent.h> 

/* ************************************************************************* */
class Point3d;
class Vector3d;
class Quaternion;
class Matrix4d;
class View;
class Transformation;

// ************************************************************************* //
/// DESCRIPTION: OpenGL handle for a matrix in the scene.
// ************************************************************************* //
class Gizmo
{
protected:
  GLuint		_m_axis;
  const View		*_m_view;
  static GLuint		_s_list;
  static bool		_s_isInit;
  mutable double	_m_size;
  Matrix4d		*_m_m;
  static bool		_s_isEasy;
public:
  Gizmo(const View &view, Matrix4d &m);
  void			glRender() const;
  void			glSelect() const;
  void			select(const GLuint axis) { _m_axis = axis; }
  void			glInitLists() const;
  Vector3d		getConstrainAxis() const;
  void			transform(const QMouseEvent &e0, 
				  const QMouseEvent &e1);
  Transformation	*newTransform(const QMouseEvent &e0, 
				      const QMouseEvent &e1);
  void			selectTrans() const;
  void			renderTrans() const;
  void			selectRot() const;
  void			renderRot() const;
  void			selectScale() const;
  void			renderScale() const;
  void			renderCircle(const Vector3d &x, const Vector3d &y,
				     const Vector3d &v) const;
  const View		&getView() const { return *_m_view; }
  void			setView(const View &view) { _m_view = &view; }
  void			setMatrix(Matrix4d &m) { _m_m = &m; }
  static void		setEasy(const double isEasy) { _s_isEasy = isEasy; }
};

// ************************************************************************* //
#endif//__GLGIZMO_HH__
