// ************************************************************************* //
// AUTHOR: Alexis Angelidis.
// STARTED: Fri Nov  7 19:13:36 NZDT 2003.
// ************************************************************************* //
#ifndef __SWPSURFEL_HH__
#define __SWPSURFEL_HH__

// ************************************************************************* //
#include <list>
#include <vector>
#include "gfxTypes.h"

// ************************************************************************* //
class	Surfel;
class	Shape;
class	Sweep;

// ************************************************************************* //
struct PSurfel
{
  friend class	Surfel;
  Point3d		_m_p;
  Vector3d		_m_v;
public:
  PSurfel() {}
  PSurfel(const Point3d &p, const Vector3d &v): _m_p(p), _m_v(v) {}
  void	render() const { _m_v.glNormal(), _m_p.glVertex(); }
};

// ************************************************************************* //
class Surfel
{
public:
  friend class	Shape;
  friend class	Sweep;
  Point3d	_m_p, _m_oldp;
  Vector3d	_m_v, _m_oldv;
  double		_m_color;
  double		_m_detJac;
  static Vector3d	_s_color;
private:
  std::list<Surfel *>::iterator	_m_meshHandle;
  std::list<Surfel *>::iterator	_m_qHandle;
  std::list<Surfel *>		*_m_qList;
public:
  Surfel(const Point3d &p, const Vector3d &v);
  Surfel();
  void	glRender() const;
  void	glRender2() const;
  void	glRender3() const;
  void	saveSurfel();
  void	pushFrontInQueryList(std::list<Surfel *> &qlist);
  void	pushBackInQueryList(std::list<Surfel *> &qlist);
  void	remFromQueryList();
  friend std::ostream	&operator<<(std::ostream &os, const Surfel &s);
};

// ************************************************************************* //
#endif//__SWPSURFEL_HH__
