// ************************************************************************* //
/// AUTHOR: Alexis Angelidis
/// STARTED: Sat Jan 17 18:54:28 NZDT 2004
// ************************************************************************* //
#ifndef	__SWPSWEEPPROTO_HH__
#define	__SWPSWEEPPROTO_HH__

// ************************************************************************* //
#include "swpSweep.h"

// ************************************************************************* //
class ToolProto;

// ************************************************************************* //
class SweepProto: public Sweep
{
protected:
  Point3d	_m_c;
  Vector3d	_m_t, _m_z;
  double	_m_angle;
  Transformation	*_m_tstep;
  const ToolProto	&_m_tool;
public:
  SweepProto(const ToolProto &tool, const Matrix4d &msrc,
	     const Transformation &transf, const unsigned sym);
  virtual ~SweepProto() { delete _m_tstep; }
  void	sweepStep(Point3d &p) const;
  void	sweepStep(Surfel &s) const;
  void	sweep(Shape &s) const;
  double	tau(const Point3d &p) const;
  double	rho(const Point3d &p) const;
  double	alpha(const Point3d &p) const;
};

// ************************************************************************* //
#endif//__SWPSWEEPPROTO_HH__
