// ************************************************************************* //
/// AUTHOR: Alexis Angelidis
/// STARTED: Sat Jan 17 18:54:28 NZDT 2004
// ************************************************************************* //
#ifndef	__SWPSWEEPSTOKES_HH__
#define	__SWPSWEEPSTOKES_HH__

// ************************************************************************* //
#include <vector>
#include "swpSweep.h"
#include "sfSolver.h"

// ************************************************************************* //
class ToolStokes;

// ************************************************************************* //
class SweepStokes: public Sweep
{
protected:
  Point3d		_m_c;
  Transformation	*_m_tstep;
  const ToolStokes	&_m_tool;
  static Solver		*_s_solver;
  const Matrix4d	_m_invmsrc;
  Matrix4d		_m_world2solver;
  Matrix4d		_m_solver2world;
  Vector3d		_m_x, _m_y, _m_z;
  double		_m_len;//step length in solver coordinates.
public:
  SweepStokes(const ToolStokes &tool, const Matrix4d &msrc,
	     const Transformation &transf, const unsigned sym);
  virtual ~SweepStokes();
  void	sweepStep(Point3d &p) const;
  void	sweepStep(Surfel &s) const;
  void	sweep(Shape &s) const;
};

// ************************************************************************* //
#endif//__SWPSWEEPSTOKES_HH__
