// ************************************************************************* //
/// AUTHOR: Alexis Angelidis
/// STARTED: Sat Jan 17 18:54:28 NZDT 2004
// ************************************************************************* //
#ifndef	__SWPSWEEPZOOM_HH__
#define	__SWPSWEEPZOOM_HH__

// ************************************************************************* //
#include <vector>
#include "swpSweep.h"

// ************************************************************************* //
class ToolZoom;

// ************************************************************************* //
class SweepZoom: public Sweep
{
protected:
  Point3d		_m_c;
  Transformation	*_m_tstep;
  const ToolZoom	&_m_tool;
  const Matrix4d	_m_invmsrc;
  Matrix4d		_m_world2solver;
  Matrix4d		_m_solver2world;
  const double		_m_r;
  double		_m_t;
public:
  SweepZoom(const ToolZoom &tool, const Matrix4d &msrc,
	     const Transformation &transf, const unsigned sym);
  virtual ~SweepZoom();
  void	sweepStep(Point3d &p) const;
  void	sweepStep(Surfel &s) const;
  void	sweep(Shape &s) const;
};

// ************************************************************************* //
#endif//__SWPSWEEPZOOM_HH__

