// ************************************************************************* //
/// AUTHOR: Alexis Angelidis
/// STARTED: Tue Nov 25 13:45:28 NZDT 2003
// ************************************************************************* //
#ifndef __SWPTOOLPINCH_HH__
#define __SWPTOOLPINCH_HH__

// ************************************************************************* //
#include "gfxTypes.h"
#include "swpTool.h"

// ************************************************************************* //
class ToolPinch: public Tool
{
  double	_m_rIn, _m_rOut, _m_aIn, _m_aOut;
  double	_m_dist;
public:
  ToolPinch(const double k);
  double	fieldPinch(const Point3d &p, const Matrix4d &m,
			   const Matrix4d &invm, const double u) const;
  double	fieldPull(const Point3d &p, const Matrix4d &m,
			  const Matrix4d &invm, const double u) const;
  double	field(const Point3d &p, const Matrix4d &m,
		      const Matrix4d &invm) const;
  double	field(const Point3d &p, const Matrix4d &m,
		      const Matrix4d &invm, const unsigned istep) const;
  BBox3d	getBBox(const Matrix4d &m, const Matrix4d &invm) const;
  void		glRender() const;
  Sweep		*newSweep(const int sym, const Matrix4d &msrc,
			  const Transformation &transf) const;
};

// ************************************************************************* //
#endif//__SWPTOOLPINCH_HH__
