// ************************************************************************* //
/// AUTHOR: Alexis Angelidis
/// STARTED: Mon Dec  8 09:50:04 NZDT 2003
// ************************************************************************* //
#ifndef	__SWPTOOLPROTO_HH__
#define	__SWPTOOLPROTO_HH__

// ************************************************************************* //
#include "gfxTypes.h"
#include "swpTool.h"

// ************************************************************************* //
class	SweepProto;

// ************************************************************************* //
class ToolProto: public Tool
{
  friend class		SweepProto;
  const unsigned	_m_nbSpheres;
  mutable double	_m_r;
public:
  ToolProto(const double k);
  virtual ~ToolProto();
  double	field(const Point3d &p, const Matrix4d &m, 
		      const Matrix4d &invm) const;
  BBox3d	getBBox(const Matrix4d &m, const Matrix4d &invm) const;
  Sweep		*newSweep(const int sym, const Matrix4d &msrc,
			  const Transformation &transf) const;
  void		glRender() const;
  void		setPosition(const Matrix4d &m);
  double	getr() const { return _m_r; }
};

// ************************************************************************* //
#endif//__SWPTOOLPROTO_HH__
