// ************************************************************************* //
/// AUTHOR: Alexis Angelidis
/// STARTED: Mon Dec  8 09:50:04 NZDT 2003
// ************************************************************************* //
#ifndef	__SWPTOOLVOLUME_HH__
#define	__SWPTOOLVOLUME_HH__

// ************************************************************************* //
#include "gfxTypes.h"
#include "swpTool.h"

// ************************************************************************* //
class	SweepVolume;

// ************************************************************************* //
class ToolVolume: public Tool
{
  friend class		SweepVolume;
  const unsigned	_m_nbSpheres;
public:
  ToolVolume(const double k);
  virtual ~ToolVolume();
  double	field(const Point3d &p, const Matrix4d &m, 
		      const Matrix4d &invm) const;
  BBox3d	getBBox(const Matrix4d &m, const Matrix4d &invm) const;
  Sweep		*newSweep(const int sym, const Matrix4d &msrc,
			  const Transformation &transf) const;
  void		glRender() const;
  void		setPosition(const Matrix4d &m);
};

// ************************************************************************* //
#endif//__SWPTOOLVOLUME_HH__
